#include "stdafx.h"
#include "swf.h"

const int DEFAULT_WIDTH = 300;
const int DEFAULT_HEIGHT = 60;

//-------------------------------------------------------------------
CIncrementName :: CIncrementName( const char * pch ) { 
	if( strlen(pch)>=_MAX_PATH ) {
		memcpy( m_achName, pch, _MAX_PATH );
		m_bError=true;
		return;
		}

	m_bError=false;
	strcpy( m_achName, pch );

	CHAR * pchDot = strrchr( pch, '.' );		
	if( pchDot==NULL ) 
		m_bError=true;
	else if( (m_iDotPos=(pchDot-pch)) < 2 )
		m_bError=true;
	}

char * CIncrementName :: NextName( ) { 
	if( ! m_bError ) { 
		int iPos=m_iDotPos;
		bool bIncremented=false;
		
		while( ! bIncremented ) { 
			if( --iPos<0 || m_achName[iPos]<'0' || m_achName[iPos]>'9' ) {
				m_bError=bIncremented=true;
				}
			else if( m_achName[iPos]=='9' ) {
				m_achName[iPos]='0';
				}
			else {
				++m_achName[iPos];
				bIncremented=true;
				}
			}
		}
	return m_achName;
	}

//-----------------------------------------------------------------------------
CMovie :: CMovie() {
	m_iStatus=0;
	m_iDataSelect=0;
	m_iX0Data=m_iY0Data=0;
	m_iX1Data=DEFAULT_WIDTH;
	m_iY1Data=DEFAULT_HEIGHT;
	m_iX0State=m_iY0State=0;
	m_iX1State=DEFAULT_WIDTH;
	m_iY1State=DEFAULT_HEIGHT;
	
	m_iBMPMaxWidth=0;
	m_iBMPMaxHeight=0;
	
	m_iChannel=0;
		
	m_bFrame=true;			// Data components to draw
	m_bFill=true;
	m_bData=true;
	m_bHighlight=true;
	m_bIndicator=true;
	m_bClass=true;
	m_bState=true;
	m_crFrame=RGB(127,127,127);		
	m_crFill=RGB(0,0,0);
	m_crData=RGB(255,255,255);
	m_crHighlight=RGB(0,0,255);
	m_crIndicator=RGB(128,128,128);
	m_crClass=RGB(255,0,0);
	m_crState=RGB(0,255,0);
	
	m_aiDispLow = NULL;
	m_aiDispHigh = NULL;
	m_aiDispClass = NULL;
	m_aiDispState = NULL;
	m_iRenderLen = 0;

	m_iMinFrames=0;
	m_iMaxFrames=9999;
	m_iMovieSeconds=60;
	m_cBMPName="C:\\Temp\\BMPMovie";
	m_cSWFName="C:\\Temp\\SWFMovie";		
	}

CMovie :: ~CMovie() {
	if( m_aiDispLow != NULL )
		delete [] m_aiDispLow;
	if( m_aiDispHigh != NULL )
		delete [] m_aiDispHigh;
	if( m_aiDispClass != NULL )
		delete [] m_aiDispClass;
	if( m_aiDispState != NULL )
		delete [] m_aiDispState;
	}

//-- Create arrays to hold decimated data for rendering
bool CMovie :: AllocateRender( int iLen ) { 
	//-- if big enough but not too big ( > 10x ) keep existing buffers.
	if( m_iRenderLen>=iLen && m_iRenderLen<iLen*10 ) 
		return true;
	if( m_iRenderLen>0 ) { 
		delete [] m_aiDispLow;
		delete [] m_aiDispHigh;
		delete [] m_aiDispClass;
		delete [] m_aiDispState;
		}
	m_iRenderLen=0;

	if( (m_aiDispLow=new short[iLen])==NULL ) 
		return false;
	if( (m_aiDispHigh=new short[iLen])==NULL ) 
		return false;
	if( (m_aiDispClass=new short[iLen])==NULL ) 
		return false;
	if( (m_aiDispState=new short[iLen])==NULL ) 
		return false;
	m_iRenderLen=iLen;
	return true;
	}		
	
//---------------------------------------------------------
bool CMovie :: SaveFile( const char * pch ) { 
	FILE * h = fopen( pch, "wb" );
	int iJunk=1;
	
	char buf[5]="gmv2";
	fwrite( buf, 4, 1, h );
	FileSaveString( h, m_cImageFile.ConstBuffer() );
	FileSaveString( h, m_cSoundFile.ConstBuffer() );
	FileSaveString( h, m_cBMPName.ConstBuffer() );
	FileSaveString( h, m_cSWFName.ConstBuffer() );
	FileSaveString( h, m_cDataName.ConstBuffer() );
	fwrite( &iJunk, sizeof(int), 1, h );
	fwrite( &m_iDataSelect, sizeof(int), 1, h );

	fwrite( &m_iX0Data, sizeof(short), 1, h );
	fwrite( &m_iY0Data, sizeof(short), 1, h );
	fwrite( &m_iX1Data, sizeof(short), 1, h );
	fwrite( &m_iY1Data, sizeof(short), 1, h );

	fwrite( &m_iX0State, sizeof(short), 1, h );
	fwrite( &m_iY0State, sizeof(short), 1, h );
	fwrite( &m_iX1State, sizeof(short), 1, h );
	fwrite( &m_iY1State, sizeof(short), 1, h );

	fwrite( &m_bFrame, sizeof(bool), 1, h );
	fwrite( &m_bFill, sizeof(bool), 1, h );
	fwrite( &m_bData, sizeof(bool), 1, h );
	fwrite( &m_bHighlight, sizeof(bool), 1, h );
	fwrite( &m_bIndicator, sizeof(bool), 1, h );
	fwrite( &m_bClass, sizeof(bool), 1, h );
	fwrite( &m_bState, sizeof(bool), 1, h );
	fwrite( &m_crFrame, sizeof(COLORREF), 1, h );
	fwrite( &m_crFill, sizeof(COLORREF), 1, h );
	fwrite( &m_crData, sizeof(COLORREF), 1, h );
	fwrite( &m_crHighlight, sizeof(COLORREF), 1, h );
	fwrite( &m_crIndicator, sizeof(COLORREF), 1, h );
	fwrite( &m_crClass, sizeof(COLORREF), 1, h );
	fwrite( &m_crState, sizeof(COLORREF), 1, h );
	fwrite( &m_iMinFrames, sizeof(int), 1, h );
	fwrite( &m_iMaxFrames, sizeof(int), 1, h );
	fwrite( &m_iMovieSeconds, sizeof(int), 1, h );
	fwrite( &m_iChannel, sizeof(short), 1, h );
	fclose(h);	
	return true;
	}

bool CMovie :: LoadFile( const char * pch ) { 
	int iJunk=1;
	FILE * h = fopen( pch, "rb" );
	if( h==NULL ) 
		return false;
	char buf[4];							// "gmv1" header 
	fread( buf, 4, 1, h );		
	if( memcmp( buf, "gmv", 3 ) != 0 ) {
		MessageBox(NULL, "Error reading file", "Load GEM movie file", MB_OK );
		return false;
		}
	char chVersion=buf[3];				// '1', '2'
	
	FileLoadString( h, &m_cImageFile );
	FileLoadString( h, &m_cSoundFile );
	FileLoadString( h, &m_cBMPName );
	FileLoadString( h, &m_cSWFName );
	FileLoadString( h, &m_cDataName );
	fread( &iJunk, sizeof(int), 1, h );
	fread( &m_iDataSelect, sizeof(int), 1, h );
	//-- Data window
	fread( &m_iX0Data, sizeof(short), 1, h );
	fread( &m_iY0Data, sizeof(short), 1, h );
	fread( &m_iX1Data, sizeof(short), 1, h );
	fread( &m_iY1Data, sizeof(short), 1, h );
	if( m_iX1Data<=m_iX0Data ) 
		m_iX1Data = m_iX0Data+DEFAULT_WIDTH;
	if( m_iY1Data<=m_iY0Data ) 
		m_iY1Data = m_iY0Data+DEFAULT_HEIGHT;
	//--state window
	if( chVersion >= '2' ) { 
		fread( &m_iX0State, sizeof(short), 1, h );
		fread( &m_iY0State, sizeof(short), 1, h );
		fread( &m_iX1State, sizeof(short), 1, h );
		fread( &m_iY1State, sizeof(short), 1, h );
		if( m_iX1State<=m_iX0State ) 
			m_iX1State = m_iX0State+DEFAULT_WIDTH;
		if( m_iY1State<=m_iY0State ) 
			m_iY1State = m_iY0State+DEFAULT_HEIGHT;
		}
	else { 
		RECT junk;
		fread( &junk, sizeof(RECT), 1, h );
		m_iX0State=m_iX0Data;
		m_iY0State=m_iY0Data;
		m_iX1State=m_iX1Data;
		m_iY1State=m_iY1Data;
		}
		
	fread( &m_bFrame, sizeof(bool), 1, h );
	fread( &m_bFill, sizeof(bool), 1, h );
	fread( &m_bData, sizeof(bool), 1, h );
	fread( &m_bHighlight, sizeof(bool), 1, h );
	fread( &m_bIndicator, sizeof(bool), 1, h );
	fread( &m_bClass, sizeof(bool), 1, h );
	fread( &m_bState, sizeof(bool), 1, h );
	//-- colors
	fread( &m_crFrame, sizeof(COLORREF), 1, h );
	fread( &m_crFill, sizeof(COLORREF), 1, h );
	fread( &m_crData, sizeof(COLORREF), 1, h );
	fread( &m_crHighlight, sizeof(COLORREF), 1, h );
	fread( &m_crIndicator, sizeof(COLORREF), 1, h );
	fread( &m_crClass, sizeof(COLORREF), 1, h );
	fread( &m_crState, sizeof(COLORREF), 1, h );
	//--
	fread( &m_iMinFrames, sizeof(int), 1, h );
	fread( &m_iMaxFrames, sizeof(int), 1, h );
	fread( &m_iMovieSeconds, sizeof(int), 1, h );
	fread( &m_iChannel, sizeof(short), 1, h );
	fclose(h);
	return true;
	}

//---------------------------------------------------------
CBMP * CMovie :: BMP( int iBMP ) { 
	int iBMPs = m_aBMP.Count();
	if( iBMPs==0 )
		return NULL;
	return (CBMP *)m_aBMP[max(0,min(iBMPs-1,iBMP))];
	}
	
//---------------------------------------------------------
bool CMovie :: BMPLoad( const char * pchFile ) { 
	CBMP * pBmp = new CBMP;
	if( pBmp->Load( pchFile ) ) {
		//-- add to array 
		m_aBMP.AddItem( pBmp );

		//-- track largest bitmap loaded
		m_iBMPMaxHeight  = max( m_iBMPMaxHeight, pBmp->m_iHgt );
		m_iBMPMaxWidth = max( m_iBMPMaxWidth, pBmp->m_iWid );
	
	    return true;
		}
	delete pBmp;
    return false;
    }

bool CMovie :: LoadBitmaps( const char * pchFile, int iCount ) { 
	m_aBMP.DeleteAll();
	m_iBMPMaxWidth=m_iBMPMaxHeight=0;
	
	int iLen = strlen(pchFile);
	if( iLen>_MAX_PATH-4 || iLen<5 ) {
		MessageBox( NULL, "Error in file name ", "Bitmap load", MB_OK );
		return false;
		}

	if( iCount>999 ) {	// cannot occur, and if it could in the future, it is probably an error.
		MessageBox( NULL, "Too many states.", "Bitmap load", MB_OK );
		return false;
		}
		
	bool bBmpSuffixErr = pchFile[iLen-4]!= '.' 
			|| (pchFile[iLen-3]!='b' && pchFile[iLen-3]!='B')
			|| (pchFile[iLen-2]!='m' && pchFile[iLen-2]!='M')
			|| (pchFile[iLen-1]!='p' && pchFile[iLen-1]!='P')
		;

	if( iCount>=100 && ( bBmpSuffixErr || iLen<7 || pchFile[iLen-7]!='0' ) ) { 
		MessageBox( NULL, "Error in file name.  There are 100 or more states, file must end with 001.bmp", "Bitmap load", MB_OK );
		return false;
		}

	if( iCount>=10 && ( bBmpSuffixErr || iLen<6 || pchFile[iLen-6]!='0' ) ) { 
		MessageBox( NULL, "Error in file name.  There are 10 or more states, file must end with 01.bmp", "Bitmap load", MB_OK );
		return false;
		}
		
	if( bBmpSuffixErr && pchFile[iLen-5]!= '1' ) {
		MessageBox( NULL, "Error in file name.  File must end with 1.bmp.", "Bitmap load", MB_OK );
		return false;
		}

	CHAR * pchDot = strrchr( pchFile, '.' );		
	if( pchDot==NULL ) 
		return false;			// unlikely - already checked above
	int iFile, iDotPos = (pchDot-pchFile);
		
	//-- Load files 1,2,3,...		
	CIncrementName oIncrName( pchFile );
	for( iFile=1; iCount==-1 ? FileExists(oIncrName.m_achName) : iFile<=iCount; ++iFile ) { 
		//-- load the file 
		if( ! BMPLoad( oIncrName.m_achName ) ) 
			return false;

		//-- increment file number 
		oIncrName.NextName();
		}

	return true;
	}
				
//---------------------------------------------------------
//-- load .Wav file and convert (if necc.) to stereo 22khz 16 bit
// { "RIFF", iSizeOfRestOfFile (U4), "WAVE" } 
// { "fmt ", iSizeOfRestOfChunk (U4=16), (U2=1) (U2=2-Stereo) (U4=22050) (U4) (U2) (U2)
bool CMovie :: WAVLoad( const char * pchFile ) {
	//-- read wav file header	
	FILE * h = fopen( pchFile, "rb");
	if( h == NULL ) 
		return false;
		
	BYTE achRIFF[4];
	fread( achRIFF, 4, 1, h );
	if( memcmp( achRIFF, "RIFF", 4)!=0 ) {
		MessageBox( NULL, "RIFF header missing", "WAV file load", MB_OK);
		return false;
		}
	
	//-- Load header 
	int iFileLen, iChunkSize, iSampSec, iBytesSec;
	short iFormat, iChannels, iBlockAlign, iBitsSamp;
	BYTE achWAVE[4];
	BYTE ach_fmt[4];
	fread( &iFileLen, 4, 1, h );
	fread( achWAVE, 4, 1, h );
	if( memcmp( achWAVE, "WAVE", 4)!=0 ) {
		MessageBox( NULL, "WAVE header missing", "WAV file load", MB_OK);
		return false;
		}
	fread( ach_fmt, 4, 1, h );
	if( memcmp( ach_fmt, "fmt ", 4)!=0 ) {
		MessageBox( NULL, "fmt header missing", "WAV file load", MB_OK);
		return false;
		}
	
	//-- Load fmt chunk	
    fread( &iChunkSize, 4, 1, h);	// 4								# ex: 16
    fread( &iFormat, 2, 1, h);		// 2 # should be 1 : uncompressed   # ex: 1
    fread( &iChannels, 2, 1, h);	// 2 # should be 1:mono or 2:stereo # ex: 1
    fread( &iSampSec, 4, 1, h);		// 4 # should be 44100,22050,11025  # ex: 22050
    fread( &iBytesSec, 4, 1, h);	// 4 
    fread( &iBlockAlign, 2, 1, h);	// 2
    fread( &iBitsSamp, 2, 1, h);	// 2 # should be 8 or 16            # ex: 8
    if( iChunkSize>16 ) 
		fseek( h, iChunkSize-16, SEEK_CUR );

    if( iFormat!=1 
		|| (iChannels<1 || iChannels>2) 
		|| iSampSec!=22050	//	|| (iSampSec!=11025 && iSampSec!=22050 && iSampSec!=44100)
		|| (iBitsSamp!=16 && iBitsSamp!=8 ) ) { 
		MessageBox( NULL, "Format must be  : Uncompressed, 1 or 2 channel, 22050 khz, 8 or 16 bit", "WAV file load", MB_OK);
		//MessageBox( NULL, "Format must be  : Uncompressed, 1 or 2 channel, 11025/22050/44100 khz, 8 or 16 bit", "WAV file load", MB_OK);
		return false;
		}

	//---- DATA chunk 
	int iJunk;
	BYTE achDATA[4];
	
	fread( achDATA, 4, 1, h );
	if( memcmp( achDATA, "DATA", 4)!=0 ) {			// skip over a couple of junk blocks if necc. (should be 0 or 1)
		fread( &iJunk, 4, 1, h );
		fseek( h, iJunk, SEEK_CUR );
		fread( achDATA, 4, 1, h );
		}
	if( memcmp( achDATA, "DATA", 4)!=0 ) {
		fread( &iJunk, 4, 1, h );
		fseek( h, iJunk, SEEK_CUR );
		fread( achDATA, 4, 1, h );
		}
	if( memcmp( achDATA, "DATA", 4)!=0 ) {
		MessageBox( NULL, "DATA header missing", "WAV file load", MB_OK);
		return false;
		}

	int i;
	CWAV * pWav = new CWAV;
	fread( &pWav->m_iSamples, 4, 1, h );

	//-- load and convert to stereo, 16bit
	if( iBitsSamp==8 ) { 
		pWav->m_achBuf = new BYTE[ pWav->m_iSamples*4 ];
		fread( pWav->m_achBuf, iChannels, pWav->m_iSamples, h );
		if( iChannels==2 ) 
			for( i=pWav->m_iSamples*2-1; i>=0; --i ) 
				((short *)(pWav->m_achBuf))[i]=256*pWav->m_achBuf[i];
		else 
			for( i=pWav->m_iSamples-1; i>=0; i-=2 ) {
				((short *)(pWav->m_achBuf))[i*2+1]=256*pWav->m_achBuf[i];
				((short *)(pWav->m_achBuf))[i*2]=256*pWav->m_achBuf[i];
				}
		}
	else {		// must be 16 
		pWav->m_achBuf = new BYTE[ pWav->m_iSamples*4 ];
		fread( pWav->m_achBuf, iChannels, pWav->m_iSamples*2, h );
		if( iChannels==1 ) 
			for( i=pWav->m_iSamples-1; i>=0; i-=2 ) {
				((short *)(pWav->m_achBuf))[i*2+1]=((short *)(pWav->m_achBuf))[i];
				((short *)(pWav->m_achBuf))[i*2]=((short *)(pWav->m_achBuf))[i];
				}
		}

	/*
    #if iSampSec==11025 :
    #    c=''
    #    for i in range( 0, len(cResult), 2 ) : 
    #        c=c+cResult[i]+cResult[i+1]+cResult[i]+cResult[i+1]
    #    cResult=c
    
    #if iSampSec==44100 : 
    #    c=''
    #    for i in range( 0, len(cResult), 4 ) : 
    #        c=c+cResult[i]+cResult[i+1]
    #    cResult=c
	*/

	//-- clean up, add to array 
    fclose(h);
	m_aWAV.AddItem( pWav );
    return true;
	}
	
bool CMovie :: LoadSounds( const char * pchFile, int iCount ) { 
	m_aWAV.DeleteAll();

	int iLen = strlen(pchFile);
	if( iLen>_MAX_PATH-4 || iLen<5 ) {
		MessageBox( NULL, "Error in file name ", "Sounds load", MB_OK );
		return false;
		}

	if( iCount>999 ) {	// cannot occur, and if it could in the future, it is probably an error regardless.
		MessageBox( NULL, "Too many states.", "Sounds load", MB_OK );
		return false;
		}
		
	bool bWavSuffixErr = pchFile[iLen-4]!= '.' 
			|| (pchFile[iLen-3]!='w' && pchFile[iLen-3]!='W')
			|| (pchFile[iLen-2]!='a' && pchFile[iLen-2]!='A')
			|| (pchFile[iLen-1]!='v' && pchFile[iLen-1]!='V')
		;

	if( iCount>=100 && ( bWavSuffixErr || iLen<7 || pchFile[iLen-7]!='0' ) ) { 
		MessageBox( NULL, "Error in file name.  There are 100 or more states, file must end with 001.wav", "Sounds load", MB_OK );
		return false;
		}

	if( iCount>=10 && ( bWavSuffixErr || iLen<6 || pchFile[iLen-6]!='0' ) ) { 
		MessageBox( NULL, "Error in file name.  There are 10 or more states, file must end with 01.wav", "Sounds load", MB_OK );
		return false;
		}
		
	if( bWavSuffixErr && pchFile[iLen-5]!= '1' ) {
		MessageBox( NULL, "Error in file name.  File must end with 1.wav", "Sounds load", MB_OK );
		return false;
		}

	CHAR * pchDot = strrchr( pchFile, ',' );		
	if( pchDot==NULL ) 
		return false;			// unlikely - already checked above
	int iFile, iDotPos = (pchDot-pchFile);
		
	char buf[_MAX_PATH];
	strcpy( buf, pchFile );
	for( iFile=1; iCount==-1 ? FileExists(pchFile) : iFile<=iCount; ++iFile ) { 
		//-- load the file 
		if( ! WAVLoad( buf ) ) 
			return false;

		//-- increment file number 
		if( ++buf[iDotPos-1] == '9'+1 ) {			// increment 1's place
			buf[iDotPos-1]='0';						
			if( ++buf[iDotPos-2]=='9'+1 ) {			// increment 10's place
				buf[iDotPos-2]='0';
				++buf[iDotPos-3];					// increment 100's place
				}
			}
		}

	char bufMsg[100];
	sprintf( bufMsg, "%d sound files loaded.", iFile-1 );
	MessageBox( NULL, bufMsg, "GEM Movie", MB_OK );

	return true;
	}
				
bool CMovie :: ExportBmp( const char * pchFile, int iDataLen, short * aiState ) { 
	// TODO - thread this and SetStatus(1); while it is running.
	m_cBMPName.Set( pchFile );
	if( m_aBMP.Count()==0 ) 
		return false;

	int iWid = max( max( m_iBMPMaxWidth, m_iX1Data ), m_iX1State );
	int iHgt = max( max( m_iBMPMaxHeight, m_iY1Data ), m_iY1State );
	COLORREF crFill = *(COLORREF *)(BMP(0)->m_achBuf);

		//-- TODO - consider more complicated but more efficient option of copying 
		// existing bitmap to disk, except in background or data range.  Would this really 
		// make much difference since the process is likely to be dominated by the disk 
		// write time instead ?
	//-- Export files 1,2,3,...		
	CIncrementName oIncrName( pchFile );
	int iState, iFrame, iFrames = m_iMovieSeconds * MOVIE_FPS;	
	int iPosData, iPosState;

	for( iFrame=0; iFrame<iFrames; ++iFrame ) { 
		//-- determine state at current position 
		iState = aiState[ min(iDataLen-1, iFrame*iDataLen/iFrames ) ];
		
		//-- Load bitmap corresponding to state image
		CBMP bmpOut( *(BMP(iState)), crFill, iWid, iHgt );
		
		//-- Merge in data trace
		iPosData = MulDiv( iFrame, m_iX1Data-m_iX0Data+1, iFrames );
		iPosState = MulDiv( iFrame, m_iX1State-m_iX0State+1, iFrames );
		DrawDataBlock( iPosData, iPosState, &bmpOut, m_bIndicator );

		//-- write to disk 		
		bmpOut.Save( oIncrName.m_achName );	
		
		//-- increment file number 
		oIncrName.NextName();
		if( oIncrName.m_bError ) {	// The message below - could there be different errors ? 
			char buf[64];
			sprintf( buf, "%d Images Export", iFrames );
			MessageBox( NULL, "The export filename does not have enough placeholders for the number of frames.\nFor example, a filename such as Image_0001.bmp is sufficient for 9999 images.", buf, MB_OK );
			return false;
			}

		char buf[128];
		sprintf( buf, "SWF frame %d of %d", iFrame+1, iFrames );
		SetWindowText( GetClientWin(), buf );
		}

	SetWindowText( GetClientWin(), "GEM" );

	return true;
	}

bool CMovie :: ExportSwf( const char * pchFile, int iDataLen, short * aiState ) { 
	m_cSWFName.Set( pchFile );
	if( m_aBMP.Count()==0 ) 
		return false;

	int iWid = min( 800, max( max( m_iBMPMaxWidth, m_iX1Data ), m_iX1State ) );
	while( iWid%4!=0 ) 
		++iWid;
		
	int iHgt = max( max( m_iBMPMaxHeight, m_iY1Data ), m_iY1State );
	COLORREF crFill = *(COLORREF *)(BMP(0)->m_achBuf);

	//-- Export files 1,2,3,...		
	CIncrementName oIncrName( pchFile );
	int iState, iFrame, iFrames = m_iMovieSeconds * MOVIE_FPS;	
	int iPosData, iPosState;

	//-- SWF prepare 
	const int BASECHARID = 1;
	int iBaseFrameID = BASECHARID + iFrames + 1;
	int iBMPs = m_aBMP.Count();
	BYTE * p = new BYTE[ sizeof(BITMAPINFOHEADER)+iWid*iHgt*3+1 ];
	CSWF oSWF;
	oSWF.Create( pchFile, iWid, iHgt, 10, iFrames );

	for( iFrame=0; iFrame<iFrames; ++iFrame ) { 
		//-- determine state at current position 
		iState = aiState[ min(iDataLen-1, iFrame*iDataLen/iFrames ) ];
		
		//-- Load bitmap corresponding to state image
		CBMP bmpOut( *(BMP(iState)), crFill, iWid, iHgt );
		
		//-- Merge in data trace
		iPosData = MulDiv( iFrame, m_iX1Data-m_iX0Data+1, iFrames );
		iPosState = MulDiv( iFrame, m_iX1State-m_iX0State+1, iFrames );
		DrawDataBlock( iPosData, iPosState, &bmpOut, m_bIndicator );

		//-- write to disk 		
		oSWF.BMPCopy( BASECHARID+iFrame, iBaseFrameID+iFrame, iHgt, iWid, bmpOut.m_achBuf );
			// sizeof(BITMAPINFOHEADER)
		oSWF.Flush();
		
		char buf[128];
		sprintf( buf, "SWF frame %d of %d", iFrame+1, iFrames );
		SetWindowText( GetParent(GetClientWin()), buf );
		}

	SetWindowText( GetParent(GetClientWin()), "Finalizing SWF output" );

	for( int iFrame=0; iFrame<iFrames; ++iFrame ) 
		oSWF.AddFrame( iBaseFrameID+iFrame );

	SetWindowText( GetParent(GetClientWin()), "GEM" );

	oSWF.Close();
	return true;
	}

//----- Draw Data block to bitmap 
// Note : bIndicator is passed in so that OnPaint caller can skip it.
bool CMovie :: DrawDataBlock( int iPosData, int iPosState, CBMP * pBmp, bool bIndicator ) { 
	if( m_iRenderLen<=0 )
		return false;
		
	//-- Fill 
	if( m_bFill ) {
		pBmp->FillRect( m_iX0Data , pBmp->m_iHgt-m_iY0Data, m_iX1Data, pBmp->m_iHgt-m_iY1Data, m_crFill );
		pBmp->FillRect( m_iX0State, pBmp->m_iHgt-m_iY0State, m_iX1State, pBmp->m_iHgt-m_iY1State, m_crFill );
		}
	
	//-- Frame
	if( m_bFrame ) {
		pBmp->FrameRect( m_iX0Data , pBmp->m_iHgt-m_iY0Data , m_iX1Data , pBmp->m_iHgt-m_iY1Data , m_crFrame );
		pBmp->FrameRect( m_iX0State, pBmp->m_iHgt-m_iY0State, m_iX1State, pBmp->m_iHgt-m_iY1State, m_crFrame );
		}

	//-- Data trace 
	if( m_bData ) { 
		int iLow, iHigh, iPt;
		for( int iX=m_iX0Data; iX<=m_iX1Data; ++iX ) {
			iPt=iX-m_iX0Data;
			//-- range of pixels to set.
			iLow = m_aiDispLow[iPt];
			iHigh = m_aiDispHigh[iPt];

			//-- connect from prior pt to this one
			if( iPt > 0 ) {
				if( m_aiDispHigh[iPt-1]<iLow ) 
					iLow = m_aiDispHigh[iPt-1];
				else if( m_aiDispLow[iPt-1]>iHigh ) 
					iHigh = m_aiDispLow[iPt-1];
				}

			//-- draw vertical line
			pBmp->VLine( iX, pBmp->m_iHgt-m_iY1Data+iLow, 
						pBmp->m_iHgt-m_iY1Data+iHigh, 
						(! m_bHighlight || iX-m_iX0Data>=iPosData ) ? m_crData : m_crHighlight );
			}
		}
		
	//-- Indicator 
	if( bIndicator ) 
		pBmp->VLine( m_iX0Data+iPosData, pBmp->m_iHgt-(m_iY0Data+1), pBmp->m_iHgt-(m_iY1Data-1), m_crIndicator );
		
	//-- Idealized Class - draw idealization at nominal amp levels 
	if( m_bClass ) { 
		//TODO 
		}
	
	//-- Idealized State 
	if( m_bState ) { 
		for( int iX=m_iX0State; iX<=m_iX1State; ++iX ) {
			int iSt = m_aiDispState[iX-m_iX0State];
			if( m_iY1State-iSt*10>m_iY0State )
				pBmp->SetPixel( iX, pBmp->m_iHgt-(m_iY1State-iSt*10), m_crState );
			}
		if( bIndicator ) 
			pBmp->VLine( m_iX0State+iPosState, pBmp->m_iHgt-(m_iY0State+1), pBmp->m_iHgt-(m_iY1State-1), m_crIndicator );
		}

	return true;
	}

bool CMovie :: SetStatus( int iStatus ) { 
	// TODO - MUTEX this
	if( iStatus != 0 && m_iStatus != 0 ) 
		return false;
	m_iStatus=iStatus;
	return true;
	}

int CMovie :: GetStatus() { 
	return m_iStatus;
	}
